/* Copyright 2011 Joachim Zobel <jz-2011@heute-morgen.de>.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

// $Id: mod_xml2_extern.h 72 2011-09-22 17:34:55Z jo $

/**
 * This deoptionalizes the API functions for internal use
 */

#ifndef MOD_XML2_EXTERN_H
#define MOD_XML2_EXTERN_H

#include <apr_optional.h>
#include "mod_xml2.h"

#define XML2_OPT_MEMBER(x) APR_OPTIONAL_FN_TYPE(xml2_##x) *x

typedef struct {
    XML2_OPT_MEMBER(unwrap_node);
    XML2_OPT_MEMBER(wrap_node);
    XML2_OPT_MEMBER(end_bucket);
    XML2_OPT_MEMBER(make_start_bucket);
    XML2_OPT_MEMBER(abort);
    // sxpath
    XML2_OPT_MEMBER(xpath_filter_init);
    XML2_OPT_MEMBER(xpath_filter);
    XML2_OPT_MEMBER(tree_to_brigade);
    XML2_OPT_MEMBER(tree_from_brigade);

} mod_xml2_t;

APR_DECLARE_OPTIONAL_FN(mod_xml2_t, xml2_load_fns, ());

#endif

